app.factory("productsFactory", function($http){

    var factory = {};

    // read all products
    factory.readProducts = function(json_url){

        // if json url is empty, use default
        json_url = json_url==""
                    ? "http://localhost/api/product/read_paging.php"
                    : json_url;

        return $http({
            method: 'GET',
            url: json_url
        });
    };

    // create product
    factory.createProduct = function($scope){
        return $http({
            method: 'POST',
            data: {
                'name' : $scope.name,
                'description' : $scope.description,
                'price' : $scope.price,
                'category_id' : $scope.category_id
            },
            url: 'http://localhost/api/product/create.php'
        });
    };

    // read one product
    factory.readOneProduct = function(id){
        return $http({
			method: 'GET',
			url: 'http://localhost/api/product/read_one.php?id=' + id
		});
    };

    // update product
    factory.updateProduct = function($scope){

        return $http({
			method: 'POST',
			data: {
				'id' : $scope.id,
				'name' : $scope.name,
				'description' : $scope.description,
				'price' : $scope.price,
				'category_id' : $scope.category_id
			},
			url: 'http://localhost/api/product/update.php'
		});
    };

    // delete product
    factory.deleteProduct = function(id){
        return $http({
			method: 'POST',
			data: { 'id' : id },
			url: 'http://localhost/api/product/delete.php'
		});
    };

    // search all products
    factory.searchProducts = function(json_url, keywords){

        // if json url is empty, use default
        json_url = json_url==""
                    ? "http://localhost/api/product/search_paging.php?s=" + keywords
                    : json_url;

        return $http({
            method: 'GET',
            url: json_url
        });
    };

    return factory;
});
